<?php

define("ZIBAL_MERCHANT_ID", "zibal");

function httpRequestPost(string $url, array $body_list = [])
{
    $body = json_encode($body_list);
    $body_length = strlen($body);

    $opts = array(
        'http' =>
        array(
            'method'  => 'POST',
            'header'  => "Content-Type: application/json\r\n" . "Content-Length: {$body_length}\r\n",
            'content' => $body,
            'timeout' => 60
        )
    );

    $context  = stream_context_create($opts);
    $result = @file_get_contents($url, false, $context);

    if ($result) $result = json_decode($result, true);

    return $result;
}

function requestZibal($amount, $order_id, $description = "")
{
    $body = [
        "merchant" => ZIBAL_MERCHANT_ID,
        "amount" => $amount,
        "orderId" => $order_id,
        "description" => $description,
        "callbackUrl" => "http://example.com/payment/zibal.php",
    ];

    $res = httpRequestPost("https://gateway.zibal.ir/v1/request" , $body);
   
    return (is_array($res) && @$res['result'] == 100) ? $res['trackId'] : false;
}

function payZibal($trackId)
{
    $action_url = "https://gateway.zibal.ir/start/" . $trackId;
    return $action_url;
}

function verifyZibal($trackId)
{
    $body = array(
        "merchant" => ZIBAL_MERCHANT_ID,
        "trackId" => $trackId
    );

    $res = httpRequestPost('https://gateway.zibal.ir/v1/verify', $body);

    return $res;
}
